<Title>460 Notes</Title> <Body bgcolor="#00cccc" text="#000000"><H1>460 Lab Assignment #2 : MTX System</H1><pre>

                    DUE & DEMO : To be posted

Download the files  t.c s.s and mtx_booter  from  ~samples/LAB2/
Generate a bootable FD, boot from the FD and test run the simple MTX.
Lab3 is an extension of this program.


                 Modify t.c to do the following

1. Add a priority field to the PROC struct and implement a readyQueue by 
   proc.priority. Procs with the same priority are ordered FIFO. 
   Let proc[0]'s priority = 0 (the lowest), and all other proc's priority = 1.

2. Instead of creating ALL the procs in initialize(), 
   implement a
                int kfork()
   function, which creates a CHILD proc and enters the child proc into the
   readyQueue. EVERY new proc begins execution from the same body() function.
   kfork() returns the child proc's pid if succeeds, or -1 if not.

3. In main():
3-1. call  initialize()  to initialize the data structures as follows:
            running->proc[0]; 
            running->pid=0; running->prioirty=0; running->status=READY; 
           
            all other proc[i] (i>0) are in a freeList:
                freeList -> proc[1] -> proc[2] ->... ->proc[N-1] -> NULL
                            pid = i; priority = 1; status = FREE;

3-2.  call  kfork() to create proc1, which should go into the readyQueue.

      Algorithm of kfork():
      ================================================================
        PROC *p = getproc();         // get a FREE proc from freeList
              if (p==0) return -1;  // no more PROCs in freeList
              --------------------------------------------------------
              initialize p's ppid
              initialize p's kstack[] AS IF it called tswitch() before
              enter p into readyQueue (by priority)
              return p->pid
     =================================================================
       

3-3.  call  tswitch()  to switch to proc1. 

4. In the body() function, implemnet a 'f' command, which calls kfork() to 
   create a new proc. The new proc is a CHILD of the proc that called kfork().
   Add some fields to the PROC structure, e.g. ppid or parentPtr, to keep track
   of the parent-child relation.

5. Modify scheduler() to
    scheduler()
    {
       if (running->status == READY)
          enter running into readyQueue (by prioirty)
       running=dequeue FIRST proc from readyQueue;
    }

6. Implement YOUR own queue functions:
      enqueue(PROC *p, PROC **queue), which enters p into a queue;
      dequeue(PROC **queue),          which dequeue the FIRST proc from queue
      printQueue(PROC *queue),        which prints the queue
